﻿#pragma once
#include "KeyPressedArgs.h"

namespace AnalogSynth
{
	public ref class Key sealed : public Windows::UI::Xaml::Controls::Control
	{
    private:
        static Windows::UI::Xaml::DependencyProperty^ isPressedProperty;
        static Windows::UI::Xaml::DependencyProperty^ keyNumberProperty;
        static Windows::UI::Xaml::DependencyProperty^ isFirstCProperty;

        Platform::Collections::Vector<unsigned int>^ pointerList;

	public:
		Key();

        event Windows::Foundation::EventHandler<KeyPressedArgs^>^ IsPressedChanged;

        static property Windows::UI::Xaml::DependencyProperty^ IsPressedProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get() { return isPressedProperty; }
        };

        static property Windows::UI::Xaml::DependencyProperty^ KeyNumberProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get() { return keyNumberProperty; }
        }

        static property Windows::UI::Xaml::DependencyProperty^ IsFirstCProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get() { return isFirstCProperty; }
        };

        property bool IsPressed
        {
            void set(bool value) { SetValue(IsPressedProperty, value); }
            bool get() { return (bool)GetValue(IsPressedProperty); }
        };

        property int KeyNumber
        {
            void set(int value) { SetValue(KeyNumberProperty, value); }
            int get() { return (int)GetValue(KeyNumberProperty); }
        };

        property bool IsFirstC
        {
            void set(bool value) { SetValue(IsFirstCProperty, value); }
            bool get() { return (bool)GetValue(IsFirstCProperty); }
        };

   	protected:
        virtual void OnPointerEntered(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e) override;
        virtual void OnPointerPressed(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e) override;
        virtual void OnPointerReleased(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e) override;
        virtual void OnPointerExited(Windows::UI::Xaml::Input::PointerRoutedEventArgs^ e) override;

    private:
        void AddToList(unsigned int id);
        void RemoveFromList(unsigned int id);
        void CheckList();
        static void OnIsPressedChanged(Windows::UI::Xaml::DependencyObject^ sender, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args);
	};
}
