﻿//
// Octave.xaml.h
// Declaration of the Octave class
//

#pragma once
#include "Octave.g.h"
#include "Key.h"
#include "KeyPressedArgs.h"
#include "BooleanToVisibilityConverter.h"

namespace AnalogSynth
{
    public ref class Octave sealed
    {
    private:
        static Windows::UI::Xaml::DependencyProperty^ keyNumberProperty;
        static Windows::UI::Xaml::DependencyProperty^ lastKeyVisibleProperty;
        static Windows::UI::Xaml::DependencyProperty^ hasMiddleCProperty;

    public:
        Octave();

        event Windows::Foundation::EventHandler<KeyPressedArgs^>^ IsPressedChanged;

        static property Windows::UI::Xaml::DependencyProperty^ KeyNumberProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get() { return keyNumberProperty; }
        }

        static property Windows::UI::Xaml::DependencyProperty^ LastKeyVisibleProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get() { return lastKeyVisibleProperty; }
        };

        static property Windows::UI::Xaml::DependencyProperty^ HasMiddleCProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get() { return hasMiddleCProperty; }
        };
        
        property int KeyNumber
        {
            void set(int value) { SetValue(KeyNumberProperty, value); }
            int get() { return (int)GetValue(KeyNumberProperty); }
        };

        property bool LastKeyVisible
        {
            void set(bool value) { SetValue(LastKeyVisibleProperty, value); }
            bool get() { return (bool)GetValue(LastKeyVisibleProperty); }
        };

        property bool HasMiddleC
        {
            void set(bool value) { SetValue(HasMiddleCProperty, value); }
            bool get() { return (bool)GetValue(HasMiddleCProperty); }
        };

    private:
        void OnKeyIsPressedChanged(Platform::Object^ sender, AnalogSynth::KeyPressedArgs^ args);
    };
}
